'------------------------------------------------------------------------------
' 
'   ACTvZT[rX TvvO
'   MappleXC^tF[XNX
'
'   Copyrights (c) 2004-2009 Advanced Core Technologies, Inc. All rights reserved.
'
'   2004/09/09 Rev.1.00 TAT ō쐬
'   2004/12/29 Rev.1.01 RIN vZT[rXpƂďC
'   2009/01/21 Rev.2.0.1.0 ISHI |SΉAГꊇvZʕ\Ή
'   2010/02/16 Rev.2.0.1.1 ISHI |S̕\̗C
'
'------------------------------------------------------------------------------

'	Imported Namespace
Imports StandardMX.DCService
Imports AxMAPPLEXLib

'   Definition of Class
Public Class MapSMD

    '------------------------------------------------------------------------------
    '	Constants
    '------------------------------------------------------------------------------

    '   [Public]

    '   n}Ɋւ郂[h
    Public Const MAP_CONTROL_POINTSELECT As Int32 = 0                           '   H_I
    Public Const MAP_CONTROL_GRABBER As Int32 = 1                               '   n}ړ
    Public Const MAP_CONTROL_ZOOMIN As Int32 = 2                                '   g
    Public Const MAP_CONTROL_ZOOMOUT As Int32 = 3                               '   k
    '   gpACReLXg̕\x
    Public Const TEXT_LEVEL_2 As Int32 = 1                                      '   x2
    Public Const TEXT_LEVEL_4 As Int32 = 3                                      '   x4
    '   gpACReLXg̔wiF/p`̓F
    Public Const FILL_COLOR_TRANSPARENT As Int32 = -1                           '   F

    '   [Private]

    '   n}̎
    Private Const MAP_TYPE_JAPAN As Int32 = 70                                  '   {S}  (MappleX 4 ȍ~̂)
    Private Const MAP_TYPE_LOCAL_1 As Int32 = 80                                '   n}(1) (MappleX 4 ȍ~̂)
    Private Const MAP_TYPE_LOCAL_2 As Int32 = 90                                '   n}(2) (MappleX 4 ȍ~̂)
    Private Const MAP_TYPE_WIDE As Int32 = 0                                    '   Ln}
    Private Const MAP_TYPE_MIDDLE As Int32 = 1                                  '   n}
    Private Const MAP_TYPE_DETAIL As Int32 = 2                                  '   ڍגn}
    '   en}̍ŏ/őkڒl
    Private Const MAP_TYPE_JAPAN_SCALE_MIN As Int32 = 2997387                   '   {S}̍ŏl
    Private Const MAP_TYPE_JAPAN_SCALE_MAX As Int32 = 13700000                  '   {S}̍ől
    Private Const MAP_TYPE_LOCAL_1_SCALE_MIN As Int32 = 1498701                 '   n}(1)̍ŏl
    Private Const MAP_TYPE_LOCAL_1_SCALE_MAX As Int32 = 2997386                 '   n}(1)̍ől
    Private Const MAP_TYPE_LOCAL_2_SCALE_MIN As Int32 = 360001                  '   n}(2)̍ŏl
    Private Const MAP_TYPE_LOCAL_2_SCALE_MAX As Int32 = 1498700                 '   n}(2)̍ől
    Private Const MAP_TYPE_WIDE_SCALE_MIN As Int32 = 50001                      '   Ln}̍ŏl
    Private Const MAP_TYPE_WIDE_SCALE_MAX As Int32 = 360000                     '   Ln}̍ől
    Private Const MAP_TYPE_MIDDLE_SCALE_MIN As Int32 = 10001                    '   n}̍ŏl
    Private Const MAP_TYPE_MIDDLE_SCALE_MAX As Int32 = 50000                    '   n}̍ől
    Private Const MAP_TYPE_DETAIL_SCALE_MIN As Int32 = 1000                     '   ڍגn}̍ŏl
    Private Const MAP_TYPE_DETAIL_SCALE_MAX As Int32 = 10000                    '   ڍגn}̍ől
    '   ACReLXg̕\x̍ŏ/ől
    Private Const TEXT_LEVEL_MIN As Int32 = 0                                   '   x1
    Private Const TEXT_LEVEL_MAX As Int32 = 5                                   '   x6
    '   ACReLXg̕`X^C̍ŏ/ől
    Private Const TEXT_STYLE_MIN As Int32 = 0                                   '   X^C0
    Private Const TEXT_STYLE_MAX As Int32 = 7                                   '   X^C7
    '   gpACReLXg̕`X^C
    Private Const TEXT_STYLE_ONLY_ICON As Int32 = 1                             '   ACR̂
    Private Const TEXT_STYLE_ONLY_LABEL As Int32 = 2                            '   x̂
    '   gpACReLXg̃ACRhci0-79j
    Private Const TEXT_ICON_ID_POINT As Int32 = 79                              '   Point.ico79Ƃicondef.datt@Cɒ`
    '   gpACReLXg̃x/|SȂǂ̓X^Cl
    Private Const FILL_STYLE_NORMAL As Int32 = 0                                '   ʏix^j
    '   oH`Ŏgpłőm[h
    Private Const POINTS_COUNT_MAX As Int32 = 300000                            '   ftHgl
    '   ܐ/[g̐
    Private Const LINE_WIDTH_DEFAULT As Int32 = 100                             '   ftHgl
    '   n}̕\k
    Private Const SCALE_DEFAULT As Int32 = 100000                               '   ftHgl
    '   n}ӏXg̃Zp[^
    Private Const MAP_DESIGN_LIST_SEPARATOR As String = ","c                    '   J}gp
    '   MappleX̃ReLXgj[ɓo^镶
    Private Const CONTEXT_MENU_STRING_JAPAN As String = "k8001"        '   k8001
    Private Const CONTEXT_MENU_STRING_LOCAL_1 As String = "k3001"      '   k3001
    Private Const CONTEXT_MENU_STRING_LOCAL_2 As String = "k1501"      '   k1501
    Private Const CONTEXT_MENU_STRING_WIDE_1 As String = "k201"        '   k201
    Private Const CONTEXT_MENU_STRING_WIDE_2 As String = "k101"        '   k101
    Private Const CONTEXT_MENU_STRING_MIDDLE_1 As String = "k51"       '   k51
    Private Const CONTEXT_MENU_STRING_MIDDLE_2 As String = "k25番1"    '   k25番1
    Private Const CONTEXT_MENU_STRING_DETAIL_1 As String = "k11"       '   k11
    Private Const CONTEXT_MENU_STRING_DETAIL_2 As String = "k50001"      '   k50001
    Private Const CONTEXT_MENU_STRING_DETAIL_3 As String = "k25001"      '   k25001
    '   Œ胉x
    Private Const AREA_START_POINT_STRING As String = "   START   "             '   B /  ̃X^[gn_

    '------------------------------------------------------------------------------
    '	Members
    '------------------------------------------------------------------------------

    '   [Private]

    Private m_ObjMapX As AxMapX                 '   MappleX ActiveX Rg[
    Private m_MapControl As Int32               '   n}Ɋւ郂[h
    Private m_PointTextFillColor As Int32       '   n_`̃eLXg\̔wiF
    Private m_PointIconFillColor As Int32       '   n_`̃ACR\̔wiF
    Private m_PolygonFillColor As Int32         '   |S`̓F
    Private m_PolygonLineColor As Int32         '   |S`̐̐F
    Private m_DonutPolygonLineColor As Int32    '   h[ic|S`̐̐F

    '------------------------------------------------------------------------------
    '	Methods
    '------------------------------------------------------------------------------

    '   [Public]

    '   C^[tFCX̏
    '   p[^
    '       axMapX  [IN]MappleX ActiveX Rg[
    '   ߂l
    '       Ȃ
    Public Sub Initialize(ByVal axMapX As AxMapX)
        '   MappleX ActiveX Rg[̐ݒ
        m_ObjMapX = axMapX

        '   n}Ɋւ郂[h̐ݒ
        MapControl = MAP_CONTROL_POINTSELECT                                '   H_I ɐݒ
        '   ACReLXg̕\x̐ݒ
        TextLevel = TEXT_LEVEL_2                                            '   xQ ɐݒ
        '   ACReLXg̕F̐ݒ
        TextColor = RGB(255, 0, 0)                                          '   ԐF ɐݒ
        '   ACReLXg̕`X^C̐ݒ
        TextStyle = TEXT_STYLE_ONLY_LABEL                                   '   x̂ ɐݒ
        '   ACReLXg̃ACRID̐ݒ
        TextIconID = TEXT_ICON_ID_POINT                                     '   [U`ACR 79 ɐݒ
        '   ACReLXg̔wiX^C/p`̓X^C̐ݒ
        FillStyle = FILL_STYLE_NORMAL                                       '   ʏix^jɐݒ
        '   n_`̃eLXg\̔wiF̐ݒ
        PointTextFillColor = RGB(255, 255, 0)                               '   F ɐݒ
        '   n_`̃ACR\̔wiF̐ݒ
        PointIconFillColor = FILL_COLOR_TRANSPARENT                         '   F ɐݒ
        '   |S`̓F̐ݒ
        PolygonFillColor = FILL_COLOR_TRANSPARENT                           '   F ɐݒ
        '   |S`̐̐F̐ݒ
        PolygonLineColor = RGB(0, 0, 255)                                   '   Fɐݒ
        '   h[ic|S`̐̐F̐ݒ
        DonutPolygonLineColor = RGB(255, 0, 0)                              '   ԐFɐݒ
        '   ܐ/[g̐F̐ݒ
        LineColor = RGB(255, 0, 0)                                          '   ԐF ɐݒ
        '   ܐ/[g̐̐ݒ
        LineWidth = LINE_WIDTH_DEFAULT                                      '   ftHgl 100 ɐݒ

        '   n}̎ނƕ\kڒl̐ݒ
        SetScaleforSMD(SCALE_DEFAULT)                                       '   ftHgl 100000 ɐݒ

        ' ReLXgj[ɒn}̕\kڒl̐ݒ胁j[o^
        m_ObjMapX.SetContextMenu(1, CONTEXT_MENU_STRING_JAPAN, 1, 0)        '   k8001
        m_ObjMapX.SetContextMenu(2, CONTEXT_MENU_STRING_LOCAL_1, 1, 0)      '   k3001
        m_ObjMapX.SetContextMenu(3, CONTEXT_MENU_STRING_LOCAL_2, 1, 0)      '   k1501
        m_ObjMapX.SetContextMenu(4, CONTEXT_MENU_STRING_WIDE_1, 1, 0)       '   k201
        m_ObjMapX.SetContextMenu(5, CONTEXT_MENU_STRING_WIDE_2, 1, 0)       '   k101
        m_ObjMapX.SetContextMenu(6, CONTEXT_MENU_STRING_MIDDLE_1, 1, 0)     '   k51
        m_ObjMapX.SetContextMenu(7, CONTEXT_MENU_STRING_MIDDLE_2, 1, 0)     '   k25番1
        m_ObjMapX.SetContextMenu(8, CONTEXT_MENU_STRING_DETAIL_1, 1, 0)     '   k11
        m_ObjMapX.SetContextMenu(9, CONTEXT_MENU_STRING_DETAIL_2, 1, 0)     '   k50001
        m_ObjMapX.SetContextMenu(10, CONTEXT_MENU_STRING_DETAIL_3, 1, 0)    '   k25001
    End Sub

    '   [gvZ / ŒZ[gvZ ̋vZR}h\̏`悷
    '   p[^
    '       DCCommand   [IN]vZR}h\
    '   ߂l
    '       True    vZR}h\̏̕`ɐ
    '       False   vZR}h\̏̕`Ɏs
    Public Function DrawDistCalcRoute(ByVal DCCommand As DCCommand) As Boolean
        Dim lpszLabal As String     '   `悷郉x
        Dim i As Int32              '   JE^
        Dim nCustomID As Int32      '   JX^ ID
        Dim nPoints As Int32        '   |Cg

        DrawDistCalcRoute = False   '   ߂l̏

        nPoints = DCCommand.Pnts.Length '   |Cg̎擾
        '   ő|Cg𒴂ĂȂH
        If nPoints > POINTS_COUNT_MAX Then
            Exit Function
        End If

        '   ACReLXg̐ݒ
        nCustomID = m_ObjMapX.GetCustomCount() + 1  '   JX^ ID

        '   oH̕`̊Jn
        For i = 0 To nPoints - 1
            DrawDistCalcRoute = m_ObjMapX.AddPolyLine( _
            nCustomID, _
            CInt(CDbl(DCCommand.Pnts(i).Lon) * 3600000.0F), _
            CInt(CDbl(DCCommand.Pnts(i).Lat) * 3600000.0F), _
            0 _
            )
            '   oH̕`ɎsĂȂH
            If DrawDistCalcRoute = False Then
                MessageBox.Show("|Cgz̕`Ɏs܂B", "n}`", _
                                MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Function
            End If
        Next

        '   n_̕`̊Jn
        For i = 0 To DCCommand.Locs.Length - 1
            lpszLabal = (i + 1) & "  " & DCCommand.Locs(i).Time & "" + "  " + Format(DCCommand.Locs(i).Dist, "###,##0")
            DrawDistCalcRoute = DrawPoint(CDbl(DCCommand.Locs(i).Lon), CDbl(DCCommand.Locs(i).Lat), lpszLabal)
            '   n_̕`ɎsĂȂH
            If DrawDistCalcRoute = False Then
                MessageBox.Show("P[Vz̕`Ɏs܂B", "n}`", _
                                MessageBoxButtons.OK, MessageBoxIcon.Error)
                Exit Function
            End If
        Next
    End Function

    '   B / vZʂ`悷
    '   p[^
    '       points      [IN]|Sf[^z
    '       startPoint  [IN]vZ̒Sn_
    '   ߂l
    '       True    `ɐ
    '       False   `Ɏs
    Public Function DrawDistCalcArea(ByVal points As StandardMX.DCService.Pnt(), _
                                     ByVal startPoint As StandardMX.DCService.GeoPnt) As Boolean

        Dim i As Int32                      '   JE^
        Dim resultDraw As Boolean = False   '   `挋
        Dim countDelimiter As Int32 = 0     '   ؂̃JE^
        Dim customID As Int32               '   JX^ ID
        Dim pointCount As Int32             '   |Cg
        Dim lon As Double                   '   |Cgf[^̌ox
        Dim lat As Double                   '   |Cgf[^̈ܓx

        '   ő|Cg𒴂ĂȂׂ
        pointCount = points.Length          '   |Cg̎擾
        If pointCount > POINTS_COUNT_MAX Then
            Exit Function
        End If

        '   |S̕`̊Jn
        '   ACReLXg̐ݒ
        customID = m_ObjMapX.GetCustomCount() + 1          '   JX^ ID
        m_ObjMapX.SetFillColor(PolygonFillColor)           '   |S`̓Fݒ
        LineColor = PolygonLineColor                       '   |S̐̐FύX

        For i = 0 To pointCount - 1

            lon = CDbl(points(i).Lon)
            lat = CDbl(points(i).Lat)

            If lon = 0 And lat = 0 Then     '   ؂̏

                countDelimiter += 1
                customID = m_ObjMapX.GetCustomCount() + 1

                If countDelimiter = 1 Then      '   ؂肪
                    '   ̃|S̓h[ic|S
                    LineColor = DonutPolygonLineColor
                Else                            '   ؂肪P傫
                    '   ̃|S͕ʂ̃|S
                    LineColor = PolygonLineColor
                End If
            Else                                                    '   |S̏
                countDelimiter = 0
                '   |S̕`
                resultDraw = m_ObjMapX.AddPolyLine(customID, _
                                                   CInt(lon * 3600000.0F), _
                                                   CInt(lat * 3600000.0F), _
                                                   0 _
                                                  )
                '   |S̕`ɎsĂȂH
                If resultDraw = False Then
                    Return False
                End If
            End If
        Next

        '   ACReLXg̐ݒ
        customID = m_ObjMapX.GetCustomCount() + 1      '   JX^ ID

        '   n_̕`̊Jn(X^[gn_)
        Dim labal As String         '   `悷郉x
        labal = AREA_START_POINT_STRING
        resultDraw = DrawPoint(CDbl(startPoint.Lon), CDbl(startPoint.Lat), labal)
        '   n_̕`ɎsĂȂH
        If resultDraw = False Then
            MessageBox.Show("X^[gn_̕`Ɏs܂B", "n}`", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If

        Return True
    End Function

    '   ГꊇvŽʂ`悷
    '   p[^
    '       locations   [IN]P[V\̔z
    '       startPoint  [IN]vZ̒Sn_
    '   ߂l
    '       True    `ɐ
    '       False   `Ɏs
    Public Function DrawDistCalcOneWay(ByVal locations As StandardMX.DCService.Loc(), _
                                       ByVal startPoint As StandardMX.DCService.GeoPnt) As Boolean
        Dim labal As String                 '   `悷郉x
        Dim i As Int32                      '   JE^
        Dim customID As Int32               '   JX^ ID
        Dim resultDraw As Boolean = False   '   `挋

        '   ACReLXg̐ݒ
        m_ObjMapX.SetFillColor(PolygonFillColor)    '   |S`̓Fݒ
        customID = m_ObjMapX.GetCustomCount() + 1   '   JX^ ID

        '   n_̕`̊Jn(n_ꍇ)
        If locations.Length > 1 Then
            For i = 0 To locations.Length - 1
                labal = (i + 1) & "  " & locations(i).Time & "" + "  " + Format(locations(i).Dist, "###,##0")
                resultDraw = DrawPoint(CDbl(locations(i).Lon), CDbl(locations(i).Lat), labal)
                '   n_̕`ɎsĂȂH
                If resultDraw = False Then
                    MessageBox.Show("P[Vz̕`Ɏs܂B", "n}`", _
                                    MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Function
                End If
            Next
        End If

        '   n_̕`̊Jn(X^[gn_)
        labal = AREA_START_POINT_STRING
        resultDraw = DrawPoint(CDbl(startPoint.Lon), CDbl(startPoint.Lat), labal)
        '   n_̕`ɎsĂȂH
        If resultDraw = False Then
            MessageBox.Show("X^[gn_̕`Ɏs܂B", "n}`", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Function

    '   n}ɓH_\
    '   p[^
    '       DCCommand   [IN]vZR}h\
    '   ߂l
    '       True    H_̕\ɐ
    '       False   H_̕\Ɏs
    Public Function DrawLastLoc(ByVal DCCommand As DCCommand) As Boolean
        Dim nElement As Int32   '   QƂvfԍ

        nElement = DCCommand.Locs.Length - 1    '   Ō̗vfԍ̎擾

        '   n_̕`̊Jn(Ō̒n_)
        DrawLastLoc = DrawPoint(CDbl(DCCommand.Locs(nElement).Lon), CDbl(DCCommand.Locs(nElement).Lat), CStr(nElement + 1))
        '   n_̕`ɎsĂȂH
        If DrawLastLoc = False Then
            MessageBox.Show("P[V̕`Ɏs܂B", "n}`", _
                            MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Function

    '   n}̒S_ݒ肷
    '   p[^
    '       nLon    [IN]S_ɐݒ肷ox
    '       nLat    [IN]S_ɐݒ肷ܓx
    '   ߂l
    '       Ȃ
    Public Sub PanMap(ByVal nLon As Int32, ByVal nLat As Int32)
        m_ObjMapX.SetPosition(nLon, nLat)
    End Sub

    '   n}̃IuWFNgSč폜
    '   p[^
    '       Ȃ
    '   ߂l
    '       Ȃ
    Public Sub ClearMap()
        m_ObjMapX.DeleteAllCustom()
    End Sub

    '   n}̕\kڒln}̎ނƕ\kڒlݒ肷( SMD p̕`kڏ)
    '   p[^
    '       nScale  [IN]k X1  X
    '   ߂l
    '       Ȃ
    Public Sub SetScaleforSMD(ByVal nScale As Int32)
        '   n}̕\kڒl؂ւn}̎ނI
        Select Case nScale
            Case MAP_TYPE_DETAIL_SCALE_MIN To MAP_TYPE_DETAIL_SCALE_MAX     '   ڍגn}
                MapType = MAP_TYPE_DETAIL
            Case MAP_TYPE_MIDDLE_SCALE_MIN To MAP_TYPE_MIDDLE_SCALE_MAX     '   n}
                MapType = MAP_TYPE_MIDDLE
            Case MAP_TYPE_WIDE_SCALE_MIN To MAP_TYPE_WIDE_SCALE_MAX         '   Ln}
                MapType = MAP_TYPE_WIDE
            Case MAP_TYPE_LOCAL_2_SCALE_MIN To MAP_TYPE_LOCAL_2_SCALE_MAX   '   n}(2)
                MapType = MAP_TYPE_LOCAL_2
            Case MAP_TYPE_LOCAL_1_SCALE_MIN To MAP_TYPE_LOCAL_1_SCALE_MAX   '   n}(1)
                MapType = MAP_TYPE_LOCAL_1
            Case MAP_TYPE_JAPAN_SCALE_MIN To MAP_TYPE_JAPAN_SCALE_MAX       '   {S}
                MapType = MAP_TYPE_JAPAN
            Case Else                                                       '   ȊO
                Exit Sub
        End Select
        MapScale = nScale  '   n}̕\kڒlݒ
    End Sub

    '   n}ӏXg쐬
    '   p[^
    '       Ȃ
    '   ߂l
    '       n}ӏXg
    '   l
    '       n}ӏXǵu,v؂Œn}ӏA񃊃XgB
    '       n}ӏ݂ȂAn}ӏ̎擾Ɏsꍇ́A
    '       ̕񂪕Ԃ܂B
    Public Function GetMapDesignList() As String
        Dim i As Int16                                  '   JE^
        Dim nMapDesignCount As Int16                    '   n}ӏ
        Dim lpszMapDesignName As String = ""            '   n}ӏ擾pobt@
        Dim lpszMapDesignList As String = ""            '   n}ӏXg
        Dim MapDesignArray() As String = Nothing        '   n}ӏi[z

        '   n}ӏ̎擾
        nMapDesignCount = m_ObjMapX.GetMdiGroupCount()

        '   n}ӏ݂͑邩H
        If nMapDesignCount = 0 Then
            Return ""
        End If

        '   n}ӏi[zmۂ
        ReDim MapDesignArray(nMapDesignCount - 1)

        '   n}ӏ擾Ĕz̊evfɐݒ肷
        For i = 0 To nMapDesignCount - 1
            '   n}ӏ̎擾ɐH
            If m_ObjMapX.GetMdiGroupName(i, lpszMapDesignName) = False Then
                Return ""
            End If

            '   n}ӏz̗vfɐݒ
            MapDesignArray(i) = lpszMapDesignName
        Next

        '   z񂩂n}ӏXg쐬
        lpszMapDesignList = String.Join(MAP_DESIGN_LIST_SEPARATOR, MapDesignArray, 0, nMapDesignCount)

        '   쐬
        Return lpszMapDesignList
    End Function

    '   [Private]

    '   n}ɒn_`悷
    '   p[^
    '       ldX         [IN]`悷n_̌ox
    '       ldY         [IN]`悷n_̈ܓx
    '       lpszLabel   [IN]`悷郉x
    '   ߂l
    '       True    n_̕`ɐ
    '       False   n_̕`Ɏs
    Private Function DrawPoint(ByVal ldX As Double, ByVal ldY As Double, ByVal lpszLabel As String) As Boolean
        Dim nLon As Int32           '   ox
        Dim nLat As Int32           '   ܓx
        Dim nCustomID As Int32      '   JX^ ID

        DrawPoint = False           '   ߂l̏

        '   ox/ܓxl̕ϊ
        nLon = CInt(ldX * 3600000.0F)   '   ox
        nLat = CInt(ldY * 3600000.0F)   '   ܓx

        '   ACReLXg̐ݒ
        TextStyle = TEXT_STYLE_ONLY_LABEL                               '   eLXg\̂߂ x̂ ɐݒ
        m_ObjMapX.SetFillColor(PointTextFillColor)                      '   eLXg\̔wiFݒ
        nCustomID = m_ObjMapX.GetCustomCount() + 1                      '   JX^ ID

        DrawPoint = m_ObjMapX.AddText(nCustomID, nLon, nLat, lpszLabel) '   eLXg\̎s

        '   eLXg\ɐH
        If DrawPoint = True Then
            '   ACReLXg̐ݒ
            TextStyle = TEXT_STYLE_ONLY_ICON                            '   ACR\̂߂ ACR̂ ɐݒ
            m_ObjMapX.SetFillColor(PointIconFillColor)                  '   ACR\̔wiFݒ
            nCustomID = m_ObjMapX.GetCustomCount() + 1                  '   JX^ ID

            DrawPoint = m_ObjMapX.AddText(nCustomID, nLon, nLat, "")    '   ACR\̎s
        End If
    End Function

    '------------------------------------------------------------------------------
    '	Properties
    '------------------------------------------------------------------------------

    '   [Public]

    '   n}Ɋւ郂[h擾/ݒ肷
    Public Property MapControl() As Int32
        '   擾
        Get
            Return m_MapControl
        End Get
        '   ݒ
        Set(ByVal nMapControl As Int32)
            '   [hl MappleX Rg[̒n}샂[hƃJ[\̐ݒs
            Select Case nMapControl
                Case MAP_CONTROL_POINTSELECT    '   H_I
                    m_ObjMapX.ToolType = 1  '    JX^I[h / J[\
                Case MAP_CONTROL_GRABBER        '   n}ړ
                    m_ObjMapX.ToolType = 0  '    n}ړ[h / Oo[J[\
                Case MAP_CONTROL_ZOOMIN         '   g
                    m_ObjMapX.ToolType = 2  '    ACReLXg̓[h / \J[\
                Case MAP_CONTROL_ZOOMOUT        '   k
                    m_ObjMapX.ToolType = 2  '    ACReLXg̓[h / \J[\
                Case Else                       '   ȊO
                    Exit Property
            End Select
            m_MapControl = nMapControl      '   [hl̐ݒ
        End Set
    End Property

    '   n}̎ނ擾/ݒ肷
    Public Property MapType() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetMapType()
        End Get
        '   ݒ
        Set(ByVal nMapType As Int32)
            '   n}̎ނ̒l͐ȒlH
            If (nMapType = MAP_TYPE_JAPAN) OrElse _
               (nMapType = MAP_TYPE_LOCAL_1) OrElse _
               (nMapType = MAP_TYPE_LOCAL_2) OrElse _
               (nMapType = MAP_TYPE_WIDE) OrElse _
               (nMapType = MAP_TYPE_MIDDLE) OrElse _
               (nMapType = MAP_TYPE_DETAIL) Then
                m_ObjMapX.SetMapType(nMapType)  '   n}̎ނ̐ݒ
            End If
        End Set
    End Property

    '   n}̕\kڒl擾/ݒ肷
    Public Property MapScale() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetScale()
        End Get
        '   ݒ
        Set(ByVal nMapScale As Int32)
            '   ݂̒n}̎ނƏƍāAݒ肷kڒl͐ȒlH
            Select Case nMapScale
                Case MAP_TYPE_DETAIL_SCALE_MIN To MAP_TYPE_DETAIL_SCALE_MAX     '   ڍגn}
                    If MapType <> MAP_TYPE_DETAIL Then
                        Exit Property
                    End If
                Case MAP_TYPE_MIDDLE_SCALE_MIN To MAP_TYPE_MIDDLE_SCALE_MAX     '   n}
                    If MapType <> MAP_TYPE_MIDDLE Then
                        Exit Property
                    End If
                Case MAP_TYPE_WIDE_SCALE_MIN To MAP_TYPE_WIDE_SCALE_MAX         '   Ln}
                    If MapType <> MAP_TYPE_WIDE Then
                        Exit Property
                    End If
                Case MAP_TYPE_LOCAL_2_SCALE_MIN To MAP_TYPE_LOCAL_2_SCALE_MAX   '   n}(2)
                    If MapType <> MAP_TYPE_LOCAL_2 Then
                        Exit Property
                    End If
                Case MAP_TYPE_LOCAL_1_SCALE_MIN To MAP_TYPE_LOCAL_1_SCALE_MAX   '   n}(1)
                    If MapType <> MAP_TYPE_LOCAL_1 Then
                        Exit Property
                    End If
                Case MAP_TYPE_JAPAN_SCALE_MIN To MAP_TYPE_JAPAN_SCALE_MAX       '   {S}
                    If MapType <> MAP_TYPE_JAPAN Then
                        Exit Property
                    End If
                Case Else                                                       '   ȊO
                    Exit Property
            End Select
            m_ObjMapX.SetScale(nMapScale)   '   kڒl̐ݒ
        End Set
    End Property

    '   n}ӏ擾/ݒ肷
    Public Property MapDesign() As String
        '   擾
        Get
            Dim lpszMapDesignPath As String = ""
            Dim lpszMapDesignName As String = ""

            '   ݎgpĂn}ӏ擾
            m_ObjMapX.GetMdiGroup(lpszMapDesignPath, lpszMapDesignName)
            '   ݂̒n}ӏԂ
            Return lpszMapDesignName
        End Get
        '   ݒ
        Set(ByVal lpszMapDesignName As String)
            '   w肵n}ӏɐݒ
            m_ObjMapX.SetMdiGroup(lpszMapDesignName)
        End Set
    End Property

    '   ACReLXg̕\x擾/ݒ肷
    Public Property TextLevel() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetTextLevel()
        End Get
        '   ݒ
        Set(ByVal nLevel As Int32)
            '   ACReLXg̕\xl͈͓̔H
            If (nLevel >= TEXT_LEVEL_MIN) AndAlso (nLevel <= TEXT_LEVEL_MAX) Then
                m_ObjMapX.SetTextLevel(nLevel)
            End If
        End Set
    End Property

    '   ACReLXg̕F擾/ݒ肷
    Public Property TextColor() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetTextColor()
        End Get
        '   ݒ
        Set(ByVal nRGB As Int32)
            '   RGB l͈͓̔H
            If (nRGB >= RGB(0, 0, 0)) AndAlso (nRGB <= RGB(255, 255, 255)) Then
                m_ObjMapX.SetTextColor(nRGB)
            End If
        End Set
    End Property

    '   ACReLXg̕`X^C擾/ݒ肷
    Public Property TextStyle() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetTextStyle()
        End Get
        '   ݒ
        Set(ByVal nTextStyle As Int32)
            '   ACReLXg̕`X^Cl͈̔͂H
            If (nTextStyle >= TEXT_STYLE_MIN) AndAlso (nTextStyle <= TEXT_STYLE_MAX) Then
                m_ObjMapX.SetTextStyle(nTextStyle)
            End If
        End Set
    End Property

    '   ACReLXg̃ACRID擾/ݒ肷
    Public Property TextIconID() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetTextIconID()
        End Get
        '   ݒ
        Set(ByVal nTextIconID As Int32)
            '   ACR ID l͈͓̔H
            If (nTextIconID >= 0) AndAlso (nTextIconID < m_ObjMapX.GetIconCount()) Then
                m_ObjMapX.SetTextIconID(nTextIconID)
            End If
        End Set
    End Property

    '   ACReLXg̔wiX^C/p`̓X^C擾/ݒ肷
    Public Property FillStyle() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetFillStyle()
        End Get
        '   ݒ
        Set(ByVal nFillStyle As Int32)
            '   X^Cl͈͓̔H
            If (nFillStyle >= 0) AndAlso (nFillStyle < m_ObjMapX.GetFillStyleCount()) Then
                m_ObjMapX.SetFillStyle(nFillStyle)
            End If
        End Set
    End Property

    '   n_`̃eLXg\̔wiF擾/ݒ肷
    Public Property PointTextFillColor() As Int32
        '   擾
        Get
            Return m_PointTextFillColor
        End Get
        '   ݒ
        Set(ByVal nRGB As Int32)
            '   RGB l͈͓̔H
            If (nRGB >= FILL_COLOR_TRANSPARENT) AndAlso (nRGB <= RGB(255, 255, 255)) Then
                m_PointTextFillColor = nRGB
            End If
        End Set
    End Property

    '   n_`̃ACR\̔wiF擾/ݒ肷
    Public Property PointIconFillColor() As Int32
        '   擾
        Get
            Return m_PointIconFillColor
        End Get
        '   ݒ
        Set(ByVal nRGB As Int32)
            '   RGB l͈͓̔H
            If (nRGB >= FILL_COLOR_TRANSPARENT) AndAlso (nRGB <= RGB(255, 255, 255)) Then
                m_PointIconFillColor = nRGB
            End If
        End Set
    End Property

    '   |S`̓F擾/ݒ肷
    Public Property PolygonFillColor() As Int32
        '   擾
        Get
            Return m_PolygonFillColor
        End Get
        '   ݒ
        Set(ByVal nRGB As Int32)
            '   RGB l͈͓̔H
            If (nRGB >= FILL_COLOR_TRANSPARENT) AndAlso (nRGB <= RGB(255, 255, 255)) Then
                m_PolygonFillColor = nRGB
            End If
        End Set
    End Property

    '   ܐ/[g̐F擾/ݒ肷
    Public Property LineColor() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetLineColor()
        End Get
        '   ݒ
        Set(ByVal nRGB As Int32)
            '   RGBl͈͓̔H
            If (nRGB >= RGB(0, 0, 0)) AndAlso (nRGB <= RGB(255, 255, 255)) Then
                m_ObjMapX.SetLineColor(nRGB)
            End If
        End Set
    End Property

    '   ܐ/[g̐擾/ݒ肷
    Public Property LineWidth() As Int32
        '   擾
        Get
            Return m_ObjMapX.GetLineWidth()
        End Get
        '   ݒ
        Set(ByVal nLineWidth As Int32)
            m_ObjMapX.SetLineWidth(nLineWidth)
        End Set
    End Property

    Public Property PolygonLineColor() As Int32
        Get
            Return m_PolygonLineColor
        End Get
        Set(ByVal color As Int32)
            '   RGBl͈͓̔H
            If (color >= RGB(0, 0, 0)) AndAlso (color <= RGB(255, 255, 255)) Then
                m_PolygonLineColor = color
            End If
        End Set
    End Property

    Public Property DonutPolygonLineColor() As Int32
        Get
            Return m_DonutPolygonLineColor
        End Get
        Set(ByVal color As Int32)
            '   RGBl͈͓̔H
            If (color >= RGB(0, 0, 0)) AndAlso (color <= RGB(255, 255, 255)) Then
                m_DonutPolygonLineColor = color
            End If
        End Set
    End Property

End Class

'   End of Source
